Index: /trunk/expressoMail1_2/js/search.js
===================================================================
--- /trunk/expressoMail1_2/js/search.js	(revision 5506)
+++ /trunk/expressoMail1_2/js/search.js	(revision 5533)
@@ -16,5 +16,5 @@
 		this.elementChecked = false;
 	}
-
+	
 	//Monta os forms dentro da janela;
 	searchE.prototype.showForms = function(value)
@@ -442,8 +442,19 @@
 	
 	searchE.prototype.make_tr_message = function(aux,border_id,i) {
+	console.log(aux);
+	/**
+	 * Preenche a estrutura de cache de mensagens para posterior consulta de 
+	 * informações sobre as mensagens no escopo global.
+	 */
+		if (!onceOpenedHeadersMessages[aux.boxname])
+			onceOpenedHeadersMessages[aux.boxname] = {};
+		onceOpenedHeadersMessages[aux.boxname][aux.uid] = aux;	
+	
 		var tr = document.createElement("TR");
 		if(typeof(preferences.line_height) != 'undefined')
 			tr.style.height = preferences.line_height;
-
+			
+		var msg_folder = get_current_folder(); 
+				
 		var mailbox = aux.boxname;
 		var uid_msg = aux.uid;
@@ -455,5 +466,5 @@
 		tr.setAttribute('name',mailbox);
 		tr.name = mailbox;
-
+		
 		if ( aux.flag.match("U") )
 			add_className(tr,'tr_msg_unread');
@@ -466,5 +477,5 @@
 		};
 
-		for(var j=0 ; j <= 10 ; j++)
+		for(var j=0 ; j <= 11 ; j++)
 		{
 			var td = document.createElement("TD");
@@ -519,11 +530,73 @@
 			{
 				td.setAttribute("width", colSizes[1][4]);
+				td.id = "td_message_followup_search_"+uid_msg;
+				td.setAttribute("class","search-result-item");
+				//td1 = "<img src ='../prototype/modules/mail/img/flagDefault.png' title='"+get_lang('Followup')+"'>";
+				td1 = '<div class="flag-edited" style="width:9px;height:6px;"><img src="../prototype/modules/mail/img/flagEditor.png"></div>';
+						
+				$(td).click(function(event, ui){	
+					var messageClickedId = $(this).attr('id').match(/td_message_followup_search_([\d]+)/)[1];
+					var flagged = DataLayer.get('followupflagged', {filter: [
+						'AND', 
+						['=', 'messageNumber', messageClickedId], 
+						['=', 'folderName', mailbox]
+					]});
+					if(flagged == '' || flagged == [] || flagged == 'undefined'){
+						/**
+						* Aplica followupflag de Acompanhamento
+						*/
+						aux.followupflagged = {
+							uid : User.me.id,
+							folderName : mailbox, 
+							messageNumber : messageClickedId, 
+							alarmTime : false, 
+							backgroundColor : '#FF2016',
+							followupflagId: '1',
+							followupflag: DataLayer.get('followupflag', '1')
+						};
+						$(this).find(".flag-edited").css("background", aux.followupflagged.backgroundColor);
+						aux.followupflagged.id = DataLayer.put('followupflagged', aux.followupflagged);
+						
+					}else if(aux.followupflagged.id){
+						/**
+						* Remover followupflag de Acompanhamento (DFD0078:RI25)
+						*/
+						$(this).find(".flag-edited").css("background", "#cccccc");
+
+
+						DataLayer.remove('followupflagged', flagged[0].id);
+						$('#td_message_followup_' + messageClickedId + ', ' + 
+						'#td_message_followup_search_' + messageClickedId).find(".flag-edited")
+						.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");
+					} else {
+						//TODO - open dialog
+					}
+					if(!DataLayer.commit()){}
+
+				});				
+			}
+			if (j == 5)
+			{
+				td.setAttribute("width", colSizes[1][5]);
+				td.id = "td_message_labels_search_"+uid_msg;
+				td.setAttribute("class","td-label-search");				
+				
+				if (aux.labels) {
+					td1 = '<img src="../prototype/modules/mail/img/tag.png">';
+					updateLabelsColumn(aux)		
+				} else {
+					td1 = '';
+				}
+			}
+			if (j == 6)
+			{
+				td.setAttribute("width", colSizes[1][6]);
 				td.id = "td_message_sent_"+uid_msg;
 				td1 = '';
 			}
 
-			if ( j == 5 )
-			{
-				td.setAttribute("width", colSizes[1][5]);
+			if ( j == 7 )
+			{
+				td.setAttribute("width", colSizes[1][7]);
 				td.className = "td_resizable";
 				td.onclick = _onclick;
@@ -536,15 +609,12 @@
 
 				var td1  = get_lang(td1).substr(get_lang(td1).length-1) == "*"?td1:get_lang(td1);
-
-									td1 = translateFolder(td1);
-
-
-				if( proxy_mensagens.is_local_folder(td1))
-				{
+				td1 = translateFolder(td1);
+
+				if (proxy_mensagens.is_local_folder(td1)) {
 					var td1 = this.aux_local_folder_display(td1);
 				}
 			}
 
-			if( j == 6 )
+			if( j == 8 )
 			{
 				var name;
@@ -557,5 +627,5 @@
 					name = name.substr(0,29) + "...";
 
-				td.setAttribute("width", colSizes[1][6]);
+				td.setAttribute("width", colSizes[1][8]);
 				td.className = "td_resizable";
 				td.onclick = _onclick;
@@ -566,5 +636,5 @@
 			}
 
-			if( j == 7 )
+			if( j == 9 )
 			{
 				var subject_encode = url_encode(subject);
@@ -575,5 +645,5 @@
 					aux.subject = aux.subject.substr(0,70) + "...";
 
-				td.setAttribute("width", colSizes[1][7]);
+				td.setAttribute("width", colSizes[1][9]);
 				td.className = "td_resizable td_msg_search_subject";
 				td.onclick = _onclick;
@@ -584,7 +654,7 @@
 			}
 
-			if( j == 8 )
-			{
-				td.setAttribute("width", colSizes[1][8]);
+			if( j == 10 )
+			{
+				td.setAttribute("width", colSizes[1][10]);
 				td.className = "td_resizable";
 				td.align		= "center";
@@ -609,5 +679,5 @@
 			}
 
-			if( j == 9 )
+			if( j == 11 )
 			{
 				td.setAttribute("width", "9.4%");//alinhamento dos campos data e tamanho
@@ -623,5 +693,5 @@
 			}
 
-			if( j == 10 )
+			if( j == 12 )
 			{
 				if (aux.flag.match("U"))
@@ -631,6 +701,20 @@
 				var td1 = '';
 			}
-			if (j<10) {
+			if (j<12) {
 				td.innerHTML = td1;
+				
+				//Carregar os followupflag nos resultados.
+				if (aux.followupflagged) {
+					$(td).attr('title', aux.followupflagged.followupflag.name)
+					.find(".flag-edited").css("background",aux.followupflagged.backgroundColor);
+					if(aux.followupflagged.isDone == "1"){
+						$(td).find(".flag-edited").find("img")
+						.attr("src", "../prototype/modules/mail/img/flagChecked.png")
+						.css("margin-left","-3px");
+					}
+				} else {
+					$(td).find(".flag-edited").css("background","#cccccc");
+				}
+				
 				tr.appendChild(td);
 			}
@@ -692,8 +776,9 @@
 			scrollSpeed: 100,
 			containment: "#divAppbox"
-		}).bind("contextmenu", function(){
-			if($(this).find("input:checkbox").attr("checked") != "checked"){
-				$(this).find("input:checkbox").trigger('click');
-				$(this).addClass("selected_msg");
+		}).bind("mouseup", function(event){
+			if(event.button == 2)
+				if($(this).find("input:checkbox").attr("checked") != "checked"){
+					$(this).find("input:checkbox").trigger('click');
+					$(this).addClass("selected_msg");
 			}
 		});
@@ -705,8 +790,7 @@
 	{
 		var data = ( Data['data'] ) ? Data['data'] : Data['data_gears'];
-		
 		if ( data == undefined )
 			return;
-		
+	
 		var cont = parseInt(0);
 
@@ -859,5 +943,7 @@
 		td_element03 = createTDElement(1,3);
 		td_element04 = createTDElement(1,4);
-		td_element1 = createTDElement(1,5,"th_resizable","left");
+		td_element05 = createTDElement(1,5);
+		td_element06 = createTDElement(1,6);
+		td_element1 = createTDElement(1,7,"th_resizable","left");
 		
 		var arrow_ascendant = function(Text)
@@ -865,5 +951,5 @@
 			return "<b>" + Text + "</b><img src='templates/"+template+"/images/arrow_ascendant.gif'>";
 		}
-		
+
 		// Ordernar Pasta
 		if ( sort_type == 'SORTBOX' /*|| sort_type == 'SORTBOX_REVERSE'*/ )
@@ -894,5 +980,5 @@
 		
 		// Ordernar Quem
-		td_element2 = createTDElement(1,6,"th_resizable","left");
+		td_element2 = createTDElement(1,8,"th_resizable","left");
 
 		if (sort_type == 'SORTFROM' || sort_type == 'SORTWHO' /*|| sort_type == 'SORTWHO_REVERSE' || sort_type == 'SORTFROM_REVERSE'*/ )
@@ -923,5 +1009,5 @@
 		
 		// Ordernar Subject
-		td_element3 = createTDElement(1,7,"th_resizable","left");
+		td_element3 = createTDElement(1,9,"th_resizable","left");
 		
 		if (sort_type == 'SORTSUBJECT' /*|| sort_type == 'SORTSUBJECT_REVERSE'*/)
@@ -952,5 +1038,5 @@
 		
 		// Ordernar Data
-		td_element4 = createTDElement(1,8,"th_resizable","center");
+		td_element4 = createTDElement(1,10,"th_resizable","center");
 		
 		if ( sort_type == 'SORTDATE' /*|| sort_type == 'SORTDATE_REVERSE'*/ )
@@ -981,5 +1067,5 @@
 
 		// Ordernar Tamanho
-		td_element5 = createTDElement(1,9,"th_resizable","center");
+		td_element5 = createTDElement(1,11,"th_resizable","center");
 		
 		if ( sort_type == 'SORTSIZE' /*|| sort_type == 'SORTSIZE_REVERSE'*/ )
@@ -1008,4 +1094,7 @@
 			td_element5.innerHTML	= ( sort_type == 'SORTSIZE_REVERSE' ) ? arrow_ascendant(get_lang("size")) : get_lang("size");
 		}
+		
+		//Abrir a Tela de de Configuracao de Acompanhamento
+		
 		
 		tr_element.appendChild(td_element0);
@@ -1014,4 +1103,6 @@
 		tr_element.appendChild(td_element03);
 		tr_element.appendChild(td_element04);
+		tr_element.appendChild(td_element05);
+		tr_element.appendChild(td_element06);
 		tr_element.appendChild(td_element1);
 		tr_element.appendChild(td_element2);
@@ -1022,4 +1113,5 @@
 		table_element.appendChild(tbody_element);
 
+		
 		var colgr_element = buildColGroup(1);
 		colgr_element.setAttribute("id","colgroup_head_"+numBox);
@@ -1624,2 +1716,3 @@
 // Cria o objeto
 var EsearchE = new searchE();
+var EsearchE = new searchE();
Index: /trunk/expressoMail1_2/js/draw_api.js
===================================================================
--- /trunk/expressoMail1_2/js/draw_api.js	(revision 5527)
+++ /trunk/expressoMail1_2/js/draw_api.js	(revision 5533)
@@ -1,3 +1,14 @@
- var openTab = {
+/**
+ * Estrutura que guarda em cache as mensagens abertas, a exemplo da estrutura utilizada
+ * na funcionalidade de anexar mensagens.
+ * Isto reduz a necessidade de acessar estruturas da tela para obter informações sobre 
+ * as mensagens, como tem sido para encaminhar, responder, etc.
+ * Manter os dados 'limpos' em uma estrutura 'somente-leitura' permite maior flexibilidade
+ * para mudar a tela e menos processamento de limpeza de dados (por exemplo retirar tags de 
+ * formatação, etc.) 
+ */
+onceOpenedHeadersMessages = {};
+
+var openTab = {
 	'type' : [], // 8 types of tabs, further info. see expressolivre.org/dev/wiki/mail/Documentacao
 	'content_id' : [],
@@ -153,4 +164,7 @@
 			var noden=document.getElementById('lnews_roottree_folders');
 			noden.style.backgroundImage="url(templates/"+template+"/images/menu/rss.png)";
+			
+			
+			
 		}
 //		cExecute('$this.rss.getChannels',handlerChannel);
@@ -206,5 +220,5 @@
 			}
 
-		/*tree_folders.draw(Element('content_folders'));
+		tree_folders.draw(Element('content_folders'));
 		if (!expresso_offline) {
 			n_root.changeState();
@@ -214,10 +228,10 @@
 			root_local.changeState();
 			tree_folders.getNodeById('local_Inbox')._select();
-		}*/
-
+		}
+		
 		var trash_span = document.getElementById(mount_url_folder(["lINBOX",special_folders["Trash"]])  + 'tree_folders'); 
-                var draft_span = document.getElementById(mount_url_folder(["lINBOX",special_folders["Drafts"]]) + 'tree_folders'); 
-                var sent_span  = document.getElementById(mount_url_folder(["lINBOX",special_folders["Sent"]]) + 'tree_folders'); 
-                var spam_span  = document.getElementById(mount_url_folder(["lINBOX",special_folders["Spam"]]) + 'tree_folders');
+		var draft_span = document.getElementById(mount_url_folder(["lINBOX",special_folders["Drafts"]]) + 'tree_folders'); 
+		var sent_span  = document.getElementById(mount_url_folder(["lINBOX",special_folders["Sent"]]) + 'tree_folders'); 
+		var spam_span  = document.getElementById(mount_url_folder(["lINBOX",special_folders["Spam"]]) + 'tree_folders');
 		//local folders
 		var sent_local_conf = this.preferences.save_in_folder.replace(mount_url_folder(["INBOX",""]),"local_");
@@ -321,5 +335,39 @@
 		}
 	}
-
+}
+
+function draw_tree_labels(){
+	labels = DataLayer.get('label',{criteria:{order: 'name'}});
+
+	$('#content_folders').append("<div id='MyMarckersList' class='acc-list list-label' ></div>").find("#MyMarckersList")
+	.append("<div class='my-labels'>" +
+				"<img src='../prototype/modules/mail/img/tag.png'/>" +
+				"<a class='title-my-labels' tabindex='0' role='button' aria-expanded='false' title='Meus marcadores'>Meus marcadores</a>" +
+				
+				"<span class='status-list-labels ui-icon ui-icon-triangle-1-s'></span>" +
+			"</div>"
+	)
+	.append(DataLayer.render("../prototype/modules/mail/templates/label_list.ejs", {labels: labels} ))
+	.find("li.label-item").css({"background-color":"#ffffff", "border-color":"#CCCCCC", "color":"#444444"}).click(function(){
+		var labelId = $(this).attr('class').match(/label-item-([\d]+[()a-zA-Z]*)/)[1];
+		search_emails("UNDELETED KEYWORD \"$Label"+labelId+"\"");
+	})
+	.find(".square-color").css("display","").click(function(){
+		$(this).parent(".label-item").each(function(){
+			configureLabels({selectedItem: $(this).attr('class').match(/label-item-([\d]+[()a-zA-Z]*)/)[1]});
+			var id_label_item = $(this).attr('class').match(/label-item-([\d]+[()a-zA-Z]*)/)[1];
+			$(".label-list-container .label-list").find(".label-item-"+id_label_item).trigger("click");
+		});
+	});
+	
+	$("#MyMarckersList a.title-my-labels").click(function() {
+		$("#MyMarckersList ul.label-list").toggleClass("hidden")
+		$('#MyMarckersList .status-list-labels').toggleClass("ui-icon-triangle-1-s");
+		$('#MyMarckersList .status-list-labels').toggleClass("ui-icon-triangle-1-n");
+	 });
+	 
+	if (!labels){
+		$(".my-labels").addClass("hidden");
+	}
 }
 
@@ -436,4 +484,5 @@
 		}
 		draw_new_tree_folder();	
+		draw_tree_labels();
 }
 
@@ -601,5 +650,6 @@
 // stores the percentages of the cells
 //var colSizes = [ ["24","24","12","12","12","16","16","20%","58%","11%","11%"], ["16","16","12","12","12","20%","20%","*","10%","10%"] ];
-var colSizes = [ ["2%","2%","1%","1%","1%","1%","2%","20%","48%","11%","11%"], ["16","16","12","12","12","20%","20%","*","10%","10%"] ];
+//var colSizes = [ ["2%","2%","1%","1%","1%","1%","2%","2%","20%","46%","11%","11%"], ["16","16","12","12","12","20%","20%","*","10%","10%"] ];
+var colSizes = [ ["2%","2%","1%","1%","1%","1%","2%","2%","2%","20%","46%","11%","11%"], ["2%","1%","1%","1%","1%","1%","1%","20%","20%","*","10%","9%"] ];
 // stores the alignments of the cells
 var colAligns = [ ['','','','','','','','left','left','center','center'], ['','','','','','left','left','left','center','center'] ];
@@ -942,5 +992,5 @@
 // Draw the inbox and another folders
 function draw_box(headers_msgs, msg_folder, alternate){
-        /*
+	/*
 	 * When the paging response is not in the correct folder you need to change folder
 	 * This occurs when the Ajax response is not fast enough and the user click in outher
@@ -968,4 +1018,60 @@
 	}
 	/* --- */
+	 
+	/**
+	 * Get the labels aplyed to the messages and saves the information 
+	 * into message array 
+	 */
+	var messageNumbers = new Array();
+	for (var i=0; i<headers_msgs.length; i++) {
+		messageNumbers.push(headers_msgs[i].msg_number);
+	}
+	var labeleds = DataLayer.get('labeled', {
+			filter: ['AND', ['IN', 'messageNumber', messageNumbers], ['=', 'folderName', msg_folder]],
+			criteria: {deepness: 2}
+		});
+
+	if(labeleds) {
+		for (var i=0; i<headers_msgs.length; i++) {
+			for (var j=0; j<labeleds.length; j++) {
+				if (labeleds[j].messageNumber == headers_msgs[i].msg_number) {
+					if (!headers_msgs[i].labels)
+						headers_msgs[i].labels = {};
+					headers_msgs[i].labels[labeleds[j].label.id] = labeleds[j].label;
+				}
+			}
+		}
+	}
+	
+	/**
+	 * Get the followupflags aplyed to the messages and saves the information 
+	 * into message array 
+	 */
+	var followupflaggeds = DataLayer.get('followupflagged', {
+			filter: ['AND', ['IN', 'messageNumber', messageNumbers], ['=', 'folderName', msg_folder]],
+			criteria: {deepness: 1}
+		});
+
+	if(followupflaggeds) {
+		for (var i=0; i<headers_msgs.length; i++) {
+			for (var j=0; j<followupflaggeds.length; j++) {
+				if (followupflaggeds[j].messageNumber == headers_msgs[i].msg_number) {
+					if (!headers_msgs[i].followupflagged)
+						headers_msgs[i].followupflagged = {};
+					headers_msgs[i].followupflagged = followupflaggeds[j];
+				}
+			}
+		}
+	}
+	
+	/**
+	 * Preenche a estrutura de cache de mensagens para posterior consulta de 
+	 * informações sobre as mensagens no escopo global.
+	 */
+	for (var i=0; i<headers_msgs.length; i++) { 
+		if (!onceOpenedHeadersMessages[current_folder])
+			onceOpenedHeadersMessages[current_folder] = {};
+		onceOpenedHeadersMessages[current_folder][headers_msgs[i].msg_number] = headers_msgs[i];
+	}
 
 	if (alternate)
@@ -1030,17 +1136,17 @@
 
 		td_element2 = createTDElement(0,1);
-		td_element3 = createTDElement(0,7,"th_resizable","left","message_header_SORTFROM_"+numBox);
+		td_element3 = createTDElement(0,8,"th_resizable","left","message_header_SORTFROM_"+numBox);
 		td_element3.onclick = function () {sort_box(search_box_type,'SORTFROM');};
 		td_element3.innerHTML = get_lang("From");
 
-		td_element4 = createTDElement(0,8,"th_resizable","left","message_header_SORTSUBJECT_"+numBox);
+		td_element4 = createTDElement(0,9,"th_resizable","left","message_header_SORTSUBJECT_"+numBox);
 		td_element4.onclick = function () {sort_box(search_box_type,'SORTSUBJECT');};
 		td_element4.innerHTML = get_lang("Subject");
 
-		td_element5 = createTDElement(0,9,"th_resizable","center","message_header_SORTARRIVAL_"+numBox);
+		td_element5 = createTDElement(0,10,"th_resizable","center","message_header_SORTARRIVAL_"+numBox);
 		td_element5.onclick = function () {sort_box(search_box_type,'SORTARRIVAL');};
 		td_element5.innerHTML = get_lang("Date");
 
-		td_element6 = createTDElement(0,10,"th_resizable","left","message_header_SORTSIZE_"+numBox);
+		td_element6 = createTDElement(0,11,"th_resizable","left","message_header_SORTSIZE_"+numBox);
 		td_element6.onclick = function () {sort_box(search_box_type,'SORTSIZE');}
 		td_element6.innerHTML = get_lang("Size");
@@ -1060,7 +1166,15 @@
 		var td_element24 = createTDElement(0,5);
 		td_element24.innerHTML = "&nbsp;";
-
-		var td_element25 = createTDElement(0,6);
+			
+		
+		var td_element25 = createTDElement(0,7);
 		td_element25.innerHTML = "&nbsp;";
+		
+		var td_element27 = createTDElement(0,8);
+		td_element25.innerHTML = "&nbsp;";
+		
+		var td_element26 = createTDElement(0,6);
+		td_element26.innerHTML = "&nbsp;";
+		
 
 		tr_element.appendChild(td_element21);
@@ -1068,5 +1182,8 @@
 		tr_element.appendChild(td_element23);
 		tr_element.appendChild(td_element24);
+		tr_element.appendChild(td_element26);
+		tr_element.appendChild(td_element27);
 		tr_element.appendChild(td_element25);
+		
 		tr_element.appendChild(td_element3);
 		tr_element.appendChild(td_element4);
@@ -1211,8 +1328,5 @@
 				},
 				helper: function(event){
-					if($(this).find("input:checkbox").attr("checked") != "checked"){
-						$(this).find("input:checkbox").trigger('click');
-						$(this).addClass("selected_msg");
-					}
+					$(this).find("input:checkbox").attr("checked", true);
 					if($("#table_box").find("tr input:checked").length > 1)
 						return $(DataLayer.render('../prototype/modules/mail/templates/draggin_box.ejs', {texto : (($("#table_box").find("tr input:checked")).length+" mensagens selecionadas"), type: "messages"}));
@@ -1228,8 +1342,9 @@
 				scrollSpeed: 100,
 				containment: "#divAppbox"
-			}).bind("contextmenu", function(){
-				if($(this).find("input:checkbox").attr("checked") != "checked"){
-					$(this).find("input:checkbox").trigger('click');
-					$(this).addClass("selected_msg");
+			}).bind("mouseup", function(event){
+				if(event.button == 2)
+					if($(this).find("input:checkbox").attr("checked") != "checked"){
+						$(this).find("input:checkbox").trigger('click');
+						$(this).addClass("selected_msg");
 				}
 			});
@@ -1255,4 +1370,5 @@
 		alert("Carregou em "+(_eTime - _bTime)+" ms");
 	}
+	
 	var msg_folder = Element('msg_folder').value;
 	var msg_number = Element('msg_number').value;
@@ -1271,5 +1387,5 @@
 	if(Element("table_quota"))
 		connector.loadScript("InfoQuota");
-
+	
 	// creates the dotted ruler which helps user to visualize resizing of columns
 	var ruler_element = document.getElementById("table_message_ruler");
@@ -1281,5 +1397,5 @@
 		document.getElementById("exmail_main_body").appendChild(ruler_element);
     }
-
+				
 }
 
@@ -1303,9 +1419,10 @@
 // Passar o parâmetro offset para esta função
 function make_tr_message(headers_msgs, msg_folder, offsetToGMT){
-                if (typeof offsetToGMT == 'undefined')
-                {
-                    // In older local messages headers_msgs.offsetToGMT is undefined.
-                    offsetToGMT = typeof headers_msgs.offsetToGMT != 'undefined'?headers_msgs.offsetToGMT:0;
-                }
+
+		if (typeof offsetToGMT == 'undefined')
+		{
+			// In older local messages headers_msgs.offsetToGMT is undefined.
+			offsetToGMT = typeof headers_msgs.offsetToGMT != 'undefined'?headers_msgs.offsetToGMT:0;
+		}
 		var tr_element = document.createElement('tr');
 		if(typeof(preferences.line_height) != 'undefined')
@@ -1350,8 +1467,6 @@
 		chk_box_element.className = "checkbox";
 		chk_box_element.setAttribute("id", "check_box_message_"+headers_msgs.msg_number);
-		chk_box_element.onclick = function(e){
-			if (is_ie)
-				changeBgColor(window.event,headers_msgs.msg_number);
-			else
+		chk_box_element.onchange = function(e){
+			//if (is_ie)
 				changeBgColor(e,headers_msgs.msg_number);
 		};
@@ -1415,5 +1530,5 @@
 
 
-		td_element25 = createTDElement(0,6,"td_msg",null,"td_message_unseen_"+headers_msgs.msg_number);
+		td_element25 = createTDElement(0,7,"td_msg",null,"td_message_unseen_"+headers_msgs.msg_number);
 		if ((headers_msgs.Unseen == 'U') || (headers_msgs.Recent == 'N'))
 			td_element25.innerHTML = "<img src ='templates/"+template+"/images/unseen.gif' title='"+get_lang('Unseen')+"'>";
@@ -1422,5 +1537,5 @@
 
 
-		td_element3 = createTDElement(0,7,"td_msg td_resizable","left","td_from_"+ headers_msgs.msg_number);
+		td_element3 = createTDElement(0,8,"td_msg td_resizable","left","td_from_"+ headers_msgs.msg_number);
 		var _onclick = function(){InfoContact.hide();proxy_mensagens.get_msg(headers_msgs.msg_number, msg_folder,true, show_msg);};
 		td_element3.onclick = _onclick;
@@ -1483,5 +1598,5 @@
 		}
 
-		td_element4 = createTDElement(0,8,"td_msg td_resizable","left");
+		td_element4 = createTDElement(0,9,"td_msg td_resizable","left");
 		td_element4.className += " td_msg_subject";
 		td_element4.onclick = _onclick;
@@ -1511,9 +1626,84 @@
 			td_element4.innerHTML += "</a>";
 		}
-
-
-		td_element5 = createTDElement(0,9,"td_msg td_resizable","center");
+		
+		td_element5 = createTDElement(0,10,"td_msg td_resizable","center");
 		td_element5.onclick = _onclick;
-
+		
+		td_element27 = createTDElement(0,7,"td_msg",null,"td_message_labels_"+headers_msgs.msg_number);
+		$(td_element27).addClass("td-label");
+
+		if (headers_msgs.labels) {
+			td_element27.innerHTML = '<img src="../prototype/modules/mail/img/tag.png">';
+			updateLabelsColumn(headers_msgs)		
+		}
+		
+		td_element26 = createTDElement(0,6,"td_msg",null,"td_message_followup_"+headers_msgs.msg_number);
+		$(td_element26).addClass("td-followup-flag");
+		td_element26.innerHTML = '<div class="flag-edited" style="width:9px;height:6px;"><img src="../prototype/modules/mail/img/flagEditor.png"></div>';
+	
+		if (headers_msgs.followupflagged) {
+			$(td_element26).attr('title', headers_msgs.followupflagged.followupflag.name)
+			.find(".flag-edited").css("background",headers_msgs.followupflagged.backgroundColor);
+			if(headers_msgs.followupflagged.isDone == "1"){
+				$(td_element26).find(".flag-edited").find("img")
+				.attr("src", "../prototype/modules/mail/img/flagChecked.png")
+				.css("margin-left","-3px");
+			}
+		} else {
+			$(td_element26).find(".flag-edited").css("background","#cccccc");
+		}
+		
+		/**
+		 * Clique para aplicar sinalizador
+		 */
+		$(td_element26).click(function() {	
+			
+			var messageClickedId = $(this).attr('id').match(/td_message_followup_([\d]+)/)[1];
+			 /**
+				* Hack:
+				* headers_msgs.followupflagged.id não vai funcionar porque já foi feito DataLayer.commit()
+				* por isso o id deve ser obtido do banco
+				* também para verificar se há ou não sinalizador nesta mensagem
+			*/
+			var flagged = DataLayer.get('followupflagged', {filter: [
+				'AND', 
+				['=', 'messageNumber', messageClickedId], 
+				['=', 'folderName', msg_folder]
+			]});
+			if (flagged == '' || flagged == [] || flagged == 'undefined') {
+				/**
+				 * Aplica followupflag de Acompanhamento
+				 */
+
+				headers_msgs.followupflagged = {
+					uid : User.me.id,
+					folderName : msg_folder, 
+					messageNumber : messageClickedId, 
+					alarmTime : false, 
+					backgroundColor : '#FF2016',
+					followupflagId: '1',
+					followupflag: DataLayer.get('followupflag', '1')
+				};
+				$(this).find(".flag-edited").css("background", headers_msgs.followupflagged.backgroundColor);
+				headers_msgs.followupflagged.id = DataLayer.put('followupflagged', headers_msgs.followupflagged);
+				
+			} else if (headers_msgs.followupflagged.followupflag.name == 'Follow up') {
+				/**
+				 * Remover followupflag de Acompanhamento (DFD0078:RI25)
+				 */
+				 $(this).find(".flag-edited").css("background", "#cccccc");
+
+
+				DataLayer.remove('followupflagged', flagged[0].id);
+				$('#td_message_followup_' + messageClickedId + ', ' + 
+				'#td_message_followup_search_' + messageClickedId).find(".flag-edited")
+				.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");
+			} else {
+				$(tr_element).addClass('selected_msg').find(':checkbox').trigger('click');
+				configureFollowupflag();
+			}
+			
+		});	
+		
 		var norm = function (arg) {return (arg < 10 ? '0'+arg : arg);};
 		var weekDays = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];
@@ -1557,5 +1747,5 @@
 		td_element5.alt = td_element5.title;
 
-		td_element6 = createTDElement(0,10,"td_msg td_resizable","center");
+		td_element6 = createTDElement(0,11,"td_msg td_resizable","center");
 		td_element6.onclick = _onclick;
 		td_element6.setAttribute("noWrap","true");
@@ -1567,6 +1757,9 @@
 		tr_element.appendChild(td_element22);
 		tr_element.appendChild(td_element23);
-			tr_element.appendChild(td_element24);
+		tr_element.appendChild(td_element24);
+		tr_element.appendChild(td_element26);
+		tr_element.appendChild(td_element27);
 		tr_element.appendChild(td_element25);
+
 		tr_element.appendChild(td_element3);
 		tr_element.appendChild(td_element4);
@@ -3386,5 +3579,5 @@
             if ((e.keyCode) == 120) //F9
 			{
-                emQuickSearch(input_replyto.value, 'replyto', ID, undefined,true);
+                emQuickSearch(input_replyto.value, 'replyto', ID);
 			}
 			else
@@ -3412,5 +3605,5 @@
 			if ((window.event.keyCode) == 120) //F9
 			{
-					emQuickSearch(input_replyto.value, 'replyto', ID, undefined,true);
+					emQuickSearch(input_replyto.value, 'replyto', ID);
 			}
 			else
@@ -3453,5 +3646,5 @@
 			if ((e.keyCode) == 120) //F9
 			{
-				emQuickSearch(input_to.value, 'to', ID, undefined,true);
+				emQuickSearch(input_to.value, 'to', ID);
 			}
 			else
@@ -3479,5 +3672,5 @@
 			if ((window.event.keyCode) == 120) //F9
 			{
-				emQuickSearch(input_to.value, 'to', ID, undefined,true);
+				emQuickSearch(input_to.value, 'to', ID);
 			}
 			else
@@ -3536,5 +3729,5 @@
 			if ((e.keyCode) == 120) //F9
 			{
-				emQuickSearch(input_cc.value, 'cc', ID, undefined,true);
+				emQuickSearch(input_cc.value, 'cc', ID);
 			}
 			else
@@ -3562,5 +3755,5 @@
 			if ((window.event.keyCode) == 120) //F9
 			{
-				emQuickSearch(input_cc.value, 'cc', ID, undefined,true);
+				emQuickSearch(input_cc.value, 'cc', ID);
 			}
 			else
@@ -3608,5 +3801,5 @@
 				if ((e.keyCode) == 120) //F9
 				{
-					emQuickSearch(input_cco.value, 'cco', ID, undefined,true);
+					emQuickSearch(input_cco.value, 'cco', ID);
 				}
 				else
@@ -3633,5 +3826,5 @@
 				if ((window.event.keyCode) == 120) //F9
 				{
-					emQuickSearch(input_cco.value, 'cco', ID, undefined,true);
+					emQuickSearch(input_cco.value, 'cco', ID);
 				}
 				else
@@ -3656,5 +3849,4 @@
 	var cc_load = "";
 	a_cc_link.onclick = function () {
-		var rm = false;
 		var remove = function(){
 			document.getElementById('tr_cc_'+ID).style.display = 'none';
@@ -3662,5 +3854,4 @@
 			$("#cc_"+ID).val("");
 			$("#a_cc_link_"+ID).toggleClass("expressomail-button-icon-ative");
-			rm = true;
 		}
 		if(!($("#cc_"+ID).parent().find("div")[0])){
@@ -3682,8 +3873,6 @@
 			}
 		}
-		if (rm)
-			input_to.focus();
-		else	
-			input_cc.focus();		
+		input_cc.focus();
+		
 		return false;
 	};
@@ -4014,8 +4203,4 @@
 		$("#"+$(this).attr("name")).attr("checked", (!check ? true : false));
 		//$(this).button({ disabled: false });
-		if (RichTextEditor.plain[id] != true)
-			setTimeout("RichTextEditor.focus("+ID+")",100);			
-		else 
-			$('#body_'+ID).focus();
 	});
 	
